import gzip
import os
import tarfile
import zipfile


class DataExtraction:
    @staticmethod
    def extract_zip_file(input_file, output_folder):
        """
        This function extract the zip files

        Keyword Arguments:
        output_file -- name, name of the file that must be unzipped
        output_folder -- Dir, directory where the unzipped data must be
                               stored
        """
        # extract the data
        z = zipfile.ZipFile(input_file, 'r')
        z.extractall(output_folder)
        z.close()

    @staticmethod
    def extract_data_gz(zip_filename, outfilename):
        """
        This function extract the zip files

        Keyword Arguments:
        zip_filename -- name, name of the file that must be unzipped
        outfilename -- Dir, directory where the unzipped data must be
                               stored
        """

        with gzip.GzipFile(zip_filename, 'rb') as zf:
            file_content = zf.read()
            save_file_content = open(outfilename, 'wb')
            save_file_content.write(file_content)
        save_file_content.close()
        zf.close()
        os.remove(zip_filename)

    @staticmethod
    def extract_data_tar_gz(zip_filename, output_folder):
        """
        This function extract the tar.gz files

        Keyword Arguments:
        zip_filename -- name, name of the file that must be unzipped
        output_folder -- Dir, directory where the unzipped data must be
                               stored
        """

        os.chdir(output_folder)
        tar = tarfile.open(zip_filename, "r:gz")
        tar.extractall()
        tar.close()

    @staticmethod
    def extract_data_tar(zip_filename, output_folder):
        """
        This function extract the tar files

        Keyword Arguments:
        zip_filename -- name, name of the file that must be unzipped
        output_folder -- Dir, directory where the unzipped data must be
                               stored
        """

        os.chdir(output_folder)
        tar = tarfile.open(zip_filename, "r")
        tar.extractall()
        tar.close()
